package design_pattern.flyweight;

import java.util.Collection;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class BeanInfo {
	private Map<String, PropertyDescriptor> properties = new ConcurrentHashMap<String, PropertyDescriptor>();

	public PropertyDescriptor getPropertyDescriptor(
			String propertyName) {
		if (properties.containsKey(propertyName) == true) {
			return properties.get(propertyName);
		}
		PropertyDescriptor ret = new PropertyDescriptor();
		ret.setName(propertyName);
		properties.put(propertyName, ret);
		return ret;
	}

	public Collection<PropertyDescriptor> getPropertyDescriptors() {
		return properties.values();
	}
}
