package design_pattern.intercepting_filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

public class TimerFilter implements Filter {

	public void doFilter(ServletRequest request,
			ServletResponse response, FilterChain filterChain)
			throws IOException, ServletException {

		long start = System.nanoTime();
		try {
			filterChain.doFilter(request, response);
		} finally {
			long end = System.nanoTime();
			System.out.println("Time : " + (end - start));
		}
	}

	public void init(FilterConfig config)
			throws ServletException {
	}

	public void destroy() {
	}
}
