package design_pattern.template_method;

import org.apache.log4j.Logger;

public abstract class TemplateAction {
	protected Logger logger = Logger.getLogger(this.getClass());

	public final void execute() {
		Throwable throwable = null;

		startLog();

		try {
			doExecute();
		} catch (RuntimeException e) {
			throwable = e;
			throw e;
		} catch (Error e) {
			throwable = e;
			throw e;
		} finally {
			endLog(throwable);
		}
	}

	protected abstract void doExecute();

	private void startLog() {
		if (logger.isDebugEnabled() == true) {
			logger.debug("START : " + getClass().getSimpleName()
					+ "#execute()");
		}
	}

	private void endLog(Throwable throwable) {
		if (logger.isDebugEnabled() == true) {
			logger.debug("END   : " + getClass().getSimpleName()
					+ "#execute()", throwable);
		}
	}
}
