package design_pattern.template_method.delegated;

import org.apache.log4j.Logger;

public class Processor {
	protected Logger logger = Logger.getLogger(this.getClass());

	private Action action;

	public Processor(Action action) {
		this.action = action;
	}

	public final void execute() {
		Throwable throwable = null;

		startLog();

		try {
			action.execute();
		} catch (RuntimeException e) {
			throwable = e;
			throw e;
		} catch (Error e) {
			throwable = e;
			throw e;
		} finally {
			endLog(throwable);
		}
	}

	private void startLog() {
		if (logger.isDebugEnabled() == true) {
			logger.debug("START : " + getClass().getSimpleName()
					+ "#execute()");
		}
	}

	private void endLog(Throwable throwable) {
		if (logger.isDebugEnabled() == true) {
			logger.debug("END   : " + getClass().getSimpleName()
					+ "#execute()", throwable);
		}
	}
}
